package com.xxh.cloud.healthy.behavior.application.controller;

import cn.dev33.satoken.annotation.SaCheckLogin;

import javax.servlet.http.HttpServletRequest;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import com.alibaba.fastjson2.JSON;
import com.xxh.cloud.framework.common.entity.Result;
import com.xxh.cloud.framework.common.user.AuthContextUtils;
import com.xxh.cloud.framework.common.user.LoginUser;
import com.xxh.cloud.framework.common.utils.IpUtils;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.bean.dto.PatientBehaviorUploadDTO;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.bean.vo.PatientBehaviorBaseVO;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.service.PatientBehaviorBizService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.log4j.Log4j2;

@Log4j2
@RestController
@RequestMapping("/app/healthy/patient/behavior")
@Api(tags = "用户行为管理")
public class PatientBehaviorApplicationController {
    
    @Autowired
    private PatientBehaviorBizService patientBehaviorBizService;
    
    /**
     * 添加用户行为
     */
    @SaCheckLogin
    @PostMapping("/add")
    @ApiOperation(value = "用户行为上传", response = PatientBehaviorBaseVO.class)
    public Result<PatientBehaviorBaseVO> add(HttpServletRequest request, @RequestBody PatientBehaviorUploadDTO params) {
        log.info("/app/healthy/patient/behavior/add >>> {}", JSON.toJSONString(params));
        LoginUser user = AuthContextUtils.getCurrentLoginUser();

        params.setIp(IpUtils.getIpAddr());
        params.setUa(request.getHeader("User-Agent"));
        PatientBehaviorBaseVO vo = patientBehaviorBizService.upload(params, user);
        return new Result<PatientBehaviorBaseVO>().ok(vo);
    }

}
