package com.xxh.cloud.healthy.behavior.framework.modules.biz.bean.dto;

import lombok.Getter;
import lombok.Setter;

import java.util.Date;

import javax.validation.constraints.NotEmpty;

import io.swagger.annotations.ApiModelProperty;

@Getter
@Setter
public class PatientBehaviorAddDTO {

    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "患者id", required = true)
    @NotEmpty(message = "患者id[patientId]不能为空")
    private String patientId;

    @ApiModelProperty(value = "用户id", required = true)
    @NotEmpty(message = "用户id[userId]不能为空")
    private String userId;

    @ApiModelProperty(value = "内容类型[BehaviorSourceTypeConstant.ContentTypeEnum]", required = true)
    @NotEmpty(message = "内容类型[contentType]不能为空")
    private String contentType;

    @ApiModelProperty(value = "内容ID", required = true)
    @NotEmpty(message = "内容ID[contentId]不能为空")
    private String contentId;

    @ApiModelProperty(value = "数据来源一级类型[BehaviorSourceTypeConstant.SourceOneTypeEnum]")
    private String sourceOneType;

    @ApiModelProperty(value = "数据来源一级id")
    private String sourceOneId;

    @ApiModelProperty(value = "数据来源二级类型[BehaviorSourceTypeConstant.SourceTwoTypeEnum]")
    private String sourceTwoType;

    @ApiModelProperty(value = "数据来源二级id")
    private String sourceTwoId;

    @ApiModelProperty(value = "数据来源三级类型")
    private String sourceThreeType;

    @ApiModelProperty(value = "数据来源三级id")
    private String sourceThreeId;

    @ApiModelProperty(value = "数据来源四级类型")
    private String sourceFourType;

    @ApiModelProperty(value = "数据来源四级id")
    private String sourceFourId;

    @ApiModelProperty(value = "数据来源五级类型")
    private String sourceFiveType;

    @ApiModelProperty(value = "数据来源五级id")
    private String sourceFiveId;

    @ApiModelProperty(value = "操作类型[阅读、阅读时长、感兴趣、已知晓、挂号、在线问诊、就诊]", required = true)
    @NotEmpty(message = "操作类型[operatedType]不能为空")
    private String operatedType;

    @ApiModelProperty(value = "操作时长")
    private Integer operatedDuration;

    @ApiModelProperty(value = "自定义操作内容")
    private String operatedContent;

    @ApiModelProperty("创建者")
    private String creator;

    @ApiModelProperty("创建时间")
    private Date createDate;

    @ApiModelProperty("ip")
    private String ip;
    
    @ApiModelProperty("ua")
    private String ua;
    
}
