package com.xxh.cloud.healthy.behavior.framework.modules.biz.service.impl;

import java.util.List;
import java.util.stream.Collectors;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.xxh.cloud.healthy.behavior.framework.modules.bean.entity.PatientBehaviorInfo;
import com.xxh.cloud.healthy.behavior.framework.modules.bean.service.PatientBehaviorInfoService;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.bean.dto.PatientBehaviorQueryDTO;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.bean.vo.PatientBehaviorVO;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.helper.PatientBehaviorHelper;
import com.xxh.cloud.healthy.behavior.framework.modules.biz.service.PatientBehaviorQueryBizService;

import cn.hutool.core.collection.CollectionUtil;
import cn.hutool.core.util.StrUtil;

@Service
public class PatientBehaviorQueryBizServiceImpl implements PatientBehaviorQueryBizService {

    @Autowired
    private PatientBehaviorInfoService patientBehaviorInfoService;

    @Override
    public List<PatientBehaviorVO> list(PatientBehaviorQueryDTO params) {
        List<PatientBehaviorInfo> list = patientBehaviorInfoService.list(new QueryWrapper<PatientBehaviorInfo>()
                .eq(StrUtil.isNotBlank(params.getId()), "id", params.getId())
                .eq(StrUtil.isNotBlank(params.getPatientId()), "patient_id", params.getPatientId())
                .in(CollectionUtil.isNotEmpty(params.getPatientIds()), "patient_id", params.getPatientIds())
                .eq(StrUtil.isNotBlank(params.getUserId()), "user_id", params.getUserId())
                .in(CollectionUtil.isNotEmpty(params.getUserIds()), "user_id", params.getUserIds())
                .eq(StrUtil.isNotBlank(params.getOperatedType()), "operated_type", params.getOperatedType())
        );

        return list.stream().map(PatientBehaviorHelper::getPatientBehaviorVO).collect(Collectors.toList());
    }
    
}
